#ifndef __CBRCase__H
#define __CBRCase__H

#include <string>
#include <map>
#include <iostream>
#include "CBRFeature.h"

class CBRCase {
   public:
	   //CBRCase
//get
	   int GetIntIndex(std::string);
	   float GetFloatIndex(std::string);
	   std::string GetStringIndex(std::string);
       int GetNumber();

// set
	void SetNumber(int *);
	void SetIntIndex(std::string, int);
	void SetFloatIndex(std::string, float);
	void SetStringIndex(std::string, std::string);
    
	void Print();
	double CompareTo(CBRCase &, std::map<std::string, CBRFeature> &);
	void caseCopy(CBRCase &incoming);

   private: 
	int * num;
    int index2;
	std::map<std::string, int> intIndexes;
	std::map<std::string, float> floatIndexes;
	std::map<std::string, std::string> stringIndexes;

};

#endif