#ifndef _CBRitk_h
#define _CBRitk_h


#include "CBRCase.h"
//template<class T>
//void createMatchImage(typename T::Pointer, std::string);

static bool quickie;

void setFlags(int, char* argv[]);

template<class T>
void PrintStats(typename T::Pointer image);

int itkStuff(int argc, char* argv[]);

template<class T>
typename T::Pointer createMatchImage(typename T::Pointer, std::string);

template <class T>
float ComputeMIDistance(std::string img1, std::string img2);

// I/O
template<class T>
typename T::Pointer GetImageFile(std::string file);
void WriteVVI(std::string filename, int, int, int);
//void WriteImageFile(typename T::Pointer image, std::string imgName, CBRCase &outCase);

std::vector<std::string> Split(std::string toSplit, char splitter);


template<class T>
void printSize(typename T::Pointer image);

float compareImages(std::string, std::string);

void registrationTest(char* argv[]);

template<class T>
typename T::Pointer CopySolution(typename T::Pointer image, std::string solName);

// case matching
CBRCase MatchCases(std::vector<CBRCase> cases, CBRCase &newcase);
CBRCase MatchStatistics(std::vector<CBRCase> cases, CBRCase &newcase);
template<class ImageType>
std::pair<typename ImageType::Pointer, typename ImageType::Pointer> GetImageDistance(std::string, typename ImageType::Pointer,  typename ImageType::Pointer, float &);

void BruteLast(std::vector<CBRCase> cases);

// Entry point for adaption and fixing
void ProcessCase(CBRCase &, CBRCase &);

template<class T>
typename T::Pointer Segment(typename T::Pointer image, int);

void caseBuilder(char *argv[]);

template<class T>
typename T::Pointer UseThreshold(CBRCase &, std::string, int);
void Loop(CBRCase &newCase, std::string);
void Loop2(CBRCase newCase, CBRCase oldCase, std::string);
void Loop3(CBRCase newCase, CBRCase oldCase, std::string);


void SplitAndThreshold(int, char *argv[]);
void Checkbounds(int argc, char *argv[]);
std::string ToString(int in);


void QuickMatch(CBRCase newCase, std::vector<CBRCase> cases);


template<class ImageType>
void InsertInPlaceStatistics(CBRCase & incomingCase, typename ImageType::Pointer segmented, typename ImageType::Pointer original);

/******************************/
void balle(std::string a);
void Brute2(vector<CBRCase> cases);
void UseThreshold2(CBRCase &incomingCase, std::string original, std::string used, float &printScore);
void ProcessCase2(CBRCase &oldCase, CBRCase &newCase, float score);
void PrintScoreFile(std::string dir, float full, float normal, float score);


#endif