#ifndef PLOGIC_H
#define PLOGIC_H

#include <QWidget>
#include <QString>
#include <vector>
#include <QVBoxLayout>


#include "xml2cbr.h"
#include "CBRcase.h"


class PLogic : public QWidget {
	Q_OBJECT

public:
	PLogic(QWidget *parent = 0);

protected slots:
	void ddboxChanged(int);
	void match();
	void inputIntChanged();
	void segment();
	void quickmatch();

private:
	void createInputWindow();	
	void createMatchWindow();
	void createFinalInputWindow();

	xml2cbr cbrlogic;
	QWidget *firstWindow;
	QWidget *secondWindow;
	QVBoxLayout *mLayout;
	bool busy;
};

#endif